diff --git a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitServlet.java b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitServlet.java
index 184a82b2e71a6150b763a013abd6fe89237777c0..3f663619725514c9f497cf877dcf0e69cbbd1002 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitServlet.java
@@ -135,13 +135,13 @@ public class ProfileSubmitServlet extends ProfileServlet {
 
     private void setInputsIntoContext(HttpServletRequest request, IProfile profile, IProfileContext ctx) {
         // passing inputs into context
-        Enumeration inputIds = profile.getProfileInputIds();
+        Enumeration<String> inputIds = profile.getProfileInputIds();
 
         if (inputIds != null) {
             while (inputIds.hasMoreElements()) {
                 String inputId = (String) inputIds.nextElement();
                 IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration inputNames = profileInput.getValueNames();
+                Enumeration<String> inputNames = profileInput.getValueNames();
 
                 while (inputNames.hasMoreElements()) {
                     String inputName = (String) inputNames.nextElement();
@@ -166,13 +166,13 @@ public class ProfileSubmitServlet extends ProfileServlet {
      */
     private void setInputsIntoContext(IRequest request, IProfile profile, IProfileContext ctx, Locale locale) {
         // passing inputs into context
-        Enumeration inputIds = profile.getProfileInputIds();
+        Enumeration<String> inputIds = profile.getProfileInputIds();
 
         if (inputIds != null) {
             while (inputIds.hasMoreElements()) {
                 String inputId = (String) inputIds.nextElement();
                 IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration inputNames = profileInput.getValueNames();
+                Enumeration<String> inputNames = profileInput.getValueNames();
 
                 while (inputNames.hasMoreElements()) {
                     String inputName = (String) inputNames.nextElement();
@@ -199,7 +199,7 @@ public class ProfileSubmitServlet extends ProfileServlet {
 
 
     private void setCredentialsIntoContext(HttpServletRequest request, IProfileAuthenticator authenticator, IProfileContext ctx) {
-        Enumeration authIds = authenticator.getValueNames();
+        Enumeration<String> authIds = authenticator.getValueNames();
 
         if (authIds != null) {
             CMS.debug("ProfileSubmitServlet:setCredentialsIntoContext() authNames not null");
@@ -309,7 +309,7 @@ public class ProfileSubmitServlet extends ProfileServlet {
         AuthCredentials credentials = new AuthCredentials();
 
         // build credential
-        Enumeration authNames = authenticator.getValueNames();
+        Enumeration<String> authNames = authenticator.getValueNames();
 
         if (authNames != null) {
             while (authNames.hasMoreElements()) {
@@ -335,13 +335,13 @@ public class ProfileSubmitServlet extends ProfileServlet {
     }
 
     private void setInputsIntoRequest(HttpServletRequest request, IProfile profile, IRequest req) {
-        Enumeration inputIds = profile.getProfileInputIds();
+        Enumeration<String> inputIds = profile.getProfileInputIds();
 
         if (inputIds != null) {
             while (inputIds.hasMoreElements()) {
                 String inputId = (String) inputIds.nextElement();
                 IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration inputNames = profileInput.getValueNames();
+                Enumeration<String> inputNames = profileInput.getValueNames();
 
                 if (inputNames != null) {
                     while (inputNames.hasMoreElements()) {
@@ -368,13 +368,13 @@ public class ProfileSubmitServlet extends ProfileServlet {
      */
     private void setInputsIntoRequest(IRequest request, IProfile profile, IRequest req, Locale locale) {
         // passing inputs into request
-        Enumeration inputIds = profile.getProfileInputIds();
+        Enumeration<String> inputIds = profile.getProfileInputIds();
 
         if (inputIds != null) {
             while (inputIds.hasMoreElements()) {
                 String inputId = (String) inputIds.nextElement();
                 IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration inputNames = profileInput.getValueNames();
+                Enumeration<String> inputNames = profileInput.getValueNames();
 
                 while (inputNames.hasMoreElements()) {
                     String inputName = (String) inputNames.nextElement();
@@ -399,14 +399,14 @@ public class ProfileSubmitServlet extends ProfileServlet {
     }
 
     private void setOutputIntoArgs(IProfile profile, ArgList outputlist, Locale locale, IRequest req) {
-        Enumeration outputIds = profile.getProfileOutputIds();
+        Enumeration<String> outputIds = profile.getProfileOutputIds();
 
         if (outputIds != null) {
             while (outputIds.hasMoreElements()) {
                 String outputId = (String) outputIds.nextElement();
                 IProfileOutput profileOutput = profile.getProfileOutput(outputId);
 
-                Enumeration outputNames = profileOutput.getValueNames();
+                Enumeration<String> outputNames = profileOutput.getValueNames();
 
                 if (outputNames != null) {
                     while (outputNames.hasMoreElements()) {
@@ -487,10 +487,11 @@ public class ProfileSubmitServlet extends ProfileServlet {
 
         if (CMS.debugOn()) {
             CMS.debug("Start of ProfileSubmitServlet Input Parameters");
-            Enumeration paramNames = request.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> paramNames = request.getParameterNames();
 
             while (paramNames.hasMoreElements()) {
-                String paramName = (String) paramNames.nextElement();
+                String paramName = paramNames.nextElement();
                 // added this facility so that password can be hidden,
                 // all sensitive parameters should be prefixed with 
                 // __ (double underscores); however, in the event that
@@ -749,7 +750,7 @@ public class ProfileSubmitServlet extends ProfileServlet {
                             if (origReq != null) {
                                 CMS.debug("ProfileSubmitServlet: renewal: found original enrollment request id:"+ rid);
                                 // debug: print the extData keys
-                                Enumeration en = origReq.getExtDataKeys();
+                                Enumeration<String> en = origReq.getExtDataKeys();
 /*
                                 CMS.debug("ProfileSubmitServlet: renewal: origRequest extdata key print BEGINS");
                                 while (en.hasMoreElements()) {
@@ -970,11 +971,11 @@ public class ProfileSubmitServlet extends ProfileServlet {
             CMS.debug("ProfileSubmitServlet: authentication required.");
             String uid_cred = "Unidentified";
             String uid_attempted_cred = "Unidentified";
-            Enumeration authIds = authenticator.getValueNames();
+            Enumeration<String> authIds = authenticator.getValueNames();
             //Attempt to possibly fetch attemped uid, may not always be available.
             if (authIds != null) {
                 while (authIds.hasMoreElements()) {
-                    String authName = (String) authIds.nextElement();
+                    String authName =  authIds.nextElement();
                     String value = request.getParameter(authName); 
                     if (value != null) {
                           if (authName.equals("uid")) {
@@ -1153,9 +1154,9 @@ public class ProfileSubmitServlet extends ProfileServlet {
 
             // serial auth token into request
             if (authToken != null) {
-                Enumeration tokenNames = authToken.getElements();
+                Enumeration<String> tokenNames = authToken.getElements();
                 while (tokenNames.hasMoreElements()) {
-                    String tokenName = (String) tokenNames.nextElement();
+                    String tokenName =  tokenNames.nextElement();
                     String[] tokenVals = authToken.getInStringArray(tokenName);
                     if (tokenVals != null) {
                         for (int i = 0; i < tokenVals.length; i++) {
@@ -1281,9 +1282,9 @@ public class ProfileSubmitServlet extends ProfileServlet {
                     // print request debug
                     if (reqs[k] != null) {
                       requestIds += "  "+reqs[k].getRequestId().toString();
-                      Enumeration reqKeys = reqs[k].getExtDataKeys();
+                      Enumeration<String> reqKeys = reqs[k].getExtDataKeys();
                       while (reqKeys.hasMoreElements()) {
-                        String reqKey = (String)reqKeys.nextElement();
+                        String reqKey = reqKeys.nextElement();
                         String reqVal = reqs[k].getExtDataInString(reqKey);
                         if (reqVal != null) {
                            CMS.debug("ProfileSubmitServlet: key=$request." + reqKey + "$ value=" + reqVal);
@@ -1486,15 +1487,15 @@ public class ProfileSubmitServlet extends ProfileServlet {
                 } else {
                   CMS.debug("ProfileSubmitServlet xmlOutput: no certInfo found in request");
                 }
-                Enumeration outputIds = profile.getProfileOutputIds();
+                Enumeration<String> outputIds = profile.getProfileOutputIds();
                 if (outputIds != null) {
                     while (outputIds.hasMoreElements()) {
-                        String outputId = (String) outputIds.nextElement();
+                        String outputId = outputIds.nextElement();
                         IProfileOutput profileOutput = profile.getProfileOutput(outputId);
-                        Enumeration outputNames = profileOutput.getValueNames();
+                        Enumeration<String> outputNames = profileOutput.getValueNames();
                         if (outputNames != null) {
                             while (outputNames.hasMoreElements()) {
-                                String outputName = (String) outputNames.nextElement();
+                                String outputName = outputNames.nextElement();
                                 if (!outputName.equals("b64_cert") && !outputName.equals("pkcs7"))
                                     continue;
                                 try {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/CertReqParser.java b/pki/base/common/src/com/netscape/cms/servlet/request/CertReqParser.java
index 60a8d16d5c4179ae4abb2a1c6ab8717a8ed52f00..6a9ccac5814ab31b73128d65b88b1ddc347d0898 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/CertReqParser.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/CertReqParser.java
@@ -135,7 +135,7 @@ public class CertReqParser extends ReqParser {
         arg.addStringValue("certExtsEnabled", "yes");
 
         int saCounter = 0;
-        Enumeration enum1 = req.getExtDataKeys();
+        Enumeration<String> enum1 = req.getExtDataKeys();
 
         // gross hack
         String prefix = "record."; 
@@ -144,12 +144,12 @@ public class CertReqParser extends ReqParser {
             prefix = "header.";
 
         while (enum1.hasMoreElements()) {
-            String name = (String) enum1.nextElement();
+            String name =  enum1.nextElement();
 
             if (mDetails) {
                 // show all http parameters stored in request.
                 if (name.equalsIgnoreCase(IRequest.HTTP_PARAMS)) {
-                    Hashtable http_params = req.getExtDataInHashtable(name);
+                    Hashtable<String, ?> http_params = req.getExtDataInHashtable(name);
                     // show certType specially 
                     String certType = (String) http_params.get(IRequest.CERT_TYPE);
 
@@ -163,13 +163,13 @@ public class CertReqParser extends ReqParser {
                     }
                     // show all http parameters in request
                     int counter = 0;
-                    Enumeration elms = http_params.keys();
+                    Enumeration<String> elms = http_params.keys();
 
                     while (elms.hasMoreElements()) {
                         String parami = 
                             IRequest.HTTP_PARAMS + LB + String.valueOf(counter++) + RB;
                         // hack
-                        String n = (String) elms.nextElement();
+                        String n =  elms.nextElement();
                         String rawJS = "new Object;\n\r" +
                             prefix + parami + ".name=\"" +
                             CMSTemplate.escapeJavaScriptString(n) + "\";\n\r" +
@@ -181,15 +181,15 @@ public class CertReqParser extends ReqParser {
                     }
                 } // show all http headers stored in request.
                 else if (name.equalsIgnoreCase(IRequest.HTTP_HEADERS)) {
-                    Hashtable http_hdrs = req.getExtDataInHashtable(name);
-                    Enumeration elms = http_hdrs.keys();
+                    Hashtable<String, Object> http_hdrs = req.getExtDataInHashtable(name);
+                    Enumeration<String> elms = http_hdrs.keys();
                     int counter = 0;
 
                     while (elms.hasMoreElements()) {
                         String parami = 
                             IRequest.HTTP_HEADERS + LB + String.valueOf(counter++) + RB;
                         // hack
-                        String n = (String) elms.nextElement();
+                        String n =  elms.nextElement();
                         String rawJS = "new Object;\n\r" +
                             prefix + parami + ".name=\"" +
                             CMSTemplate.escapeJavaScriptString(n) + "\";\n\r" +
@@ -202,14 +202,14 @@ public class CertReqParser extends ReqParser {
                 } // show all auth token stored in request.
                 else if (name.equalsIgnoreCase(IRequest.AUTH_TOKEN)) {
                     IAuthToken auth_token = req.getExtDataInAuthToken(name);
-                    Enumeration elms = auth_token.getElements();
+                    Enumeration<String> elms = auth_token.getElements();
                     int counter = 0;
 
                     while (elms.hasMoreElements()) {
                         String parami = 
                             IRequest.AUTH_TOKEN + LB + String.valueOf(counter++) + RB;
                         // hack
-                        String n = (String) elms.nextElement();
+                        String n =  elms.nextElement();
                         Object authTokenValue = auth_token.getInStringArray(n);
                         if (authTokenValue == null) {
                             authTokenValue = auth_token.getInString(n);
@@ -283,7 +283,7 @@ public class CertReqParser extends ReqParser {
             }
 
             if (name.equalsIgnoreCase(IRequest.ERRORS)) {
-                Vector errorStrings = req.getExtDataInStringVector(name);
+                Vector<String> errorStrings = req.getExtDataInStringVector(name);
                 if (errorStrings != null) {
                     StringBuffer errInfo = new StringBuffer();
 
@@ -355,10 +355,10 @@ public class CertReqParser extends ReqParser {
                         } catch (Exception e) {
                         }
                         if (extensions != null) {
-                            Enumeration exts = extensions.getElements();
+                            Enumeration<Extension> exts = extensions.getAttributes();
 
                             while (exts.hasMoreElements()) {
-                                Extension ext = (Extension) exts.nextElement();
+                                Extension ext = exts.nextElement();
 
                                 // only know about ns cert type
                                 if (ext instanceof NSCertTypeExtension) {
@@ -535,16 +535,16 @@ public class CertReqParser extends ReqParser {
                 }
             }
             if (name.equalsIgnoreCase(IRequest.FINGERPRINTS) && mDetails) {
-                Hashtable fingerprints = 
+                Hashtable<String, Object> fingerprints =  
                     req.getExtDataInHashtable(IRequest.FINGERPRINTS);
 
                 if (fingerprints != null) {
                     String namesAndHashes = null;
-                    Enumeration enumFingerprints = fingerprints.keys();
+                    Enumeration<String> enumFingerprints = fingerprints.keys();
 
                     while (enumFingerprints.hasMoreElements()) { 
-                        String hashname = (String) enumFingerprints.nextElement();
-                        String hashvalue = (String) fingerprints.get(hashname);
+                        String hashname = enumFingerprints.nextElement();
+                        String hashvalue =  (String) fingerprints.get(hashname);
                         byte[] fingerprint = CMS.AtoB(hashvalue);
                         String ppFingerprint = pp.toHexString(fingerprint, 0);
 
@@ -577,7 +577,8 @@ public class CertReqParser extends ReqParser {
                 int j = 0;
 
                 StringBuffer sb = new StringBuffer();
-                for (Enumeration n = ((Vector) v).elements(); n.hasMoreElements(); j++) {
+                for (@SuppressWarnings("unchecked")
+				Enumeration<String> n = ((Vector<String>)v).elements(); n.hasMoreElements(); j++) {
                     sb.append(";\n");
                     sb.append(valuename);
                     sb.append(LB);
@@ -687,7 +688,7 @@ public class CertReqParser extends ReqParser {
         }
 
         int saCounter = 0;
-        Enumeration enum1 = req.getExtDataKeys();
+        Enumeration<String> enum1 = req.getExtDataKeys();
 
         // gross hack
         String prefix = "record."; 
@@ -701,7 +702,7 @@ public class CertReqParser extends ReqParser {
             if (mDetails) {
                 // show all http parameters stored in request.
                 if (name.equalsIgnoreCase(IRequest.HTTP_PARAMS)) {
-                    Hashtable http_params = req.getExtDataInHashtable(name);
+                    Hashtable<String, Object> http_params = req.getExtDataInHashtable(name);
                     // show certType specially 
                     String certType = (String) http_params.get(IRequest.CERT_TYPE);
 
@@ -710,7 +711,7 @@ public class CertReqParser extends ReqParser {
                     }
                     // show all http parameters in request
                     int counter = 0;
-                    Enumeration elms = http_params.keys();
+                    Enumeration<String> elms = http_params.keys();
 
                     while (elms.hasMoreElements()) {
                         String parami = 
@@ -728,8 +729,8 @@ public class CertReqParser extends ReqParser {
                     }
                 } // show all http headers stored in request.
                 else if (name.equalsIgnoreCase(IRequest.HTTP_HEADERS)) {
-                    Hashtable http_hdrs = req.getExtDataInHashtable(name);
-                    Enumeration elms = http_hdrs.keys();
+                    Hashtable<String, ?> http_hdrs = req.getExtDataInHashtable(name);
+                    Enumeration<String> elms = http_hdrs.keys();
                     int counter = 0;
 
                     while (elms.hasMoreElements()) {
@@ -749,7 +750,7 @@ public class CertReqParser extends ReqParser {
                 } // show all auth token stored in request.
                 else if (name.equalsIgnoreCase(IRequest.AUTH_TOKEN)) {
                     IAuthToken auth_token = req.getExtDataInAuthToken(name);
-                    Enumeration elms = auth_token.getElements();
+                    Enumeration<String> elms = auth_token.getElements();
                     int counter = 0;
 
                     while (elms.hasMoreElements()) {
@@ -811,7 +812,7 @@ public class CertReqParser extends ReqParser {
             }
 
             if (name.equalsIgnoreCase(IRequest.ERRORS)) {
-                Vector errorsVector = req.getExtDataInStringVector(name);
+                Vector<String> errorsVector = req.getExtDataInStringVector(name);
                 if (errorsVector != null) {
                     StringBuffer errInfo = new StringBuffer();
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/ProcessCertReq.java b/pki/base/common/src/com/netscape/cms/servlet/request/ProcessCertReq.java
index 76418a9984b044e1b2942976526a20fc8bf8af8b..d19c7714e8fabc1af4dbd51c786deb52699b82d0 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/ProcessCertReq.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/ProcessCertReq.java
@@ -635,7 +635,7 @@ public class ProcessCertReq extends CMSServlet {
                             String addExts = req.getParameter("addExts");
 
                             if (addExts != null && !addExts.trim().equals("")) {
-                                Vector extsToBeAdded = new Vector();
+                                Vector<Extension> extsToBeAdded = new Vector<Extension>();
 
                                 byte[] b = (byte[]) (com.netscape.osutil.OSUtil.AtoB(addExts));
 
@@ -672,7 +672,7 @@ public class ProcessCertReq extends CMSServlet {
                                     NSCertTypeExtension nsExtensions = 
                                         (NSCertTypeExtension)
                                         extensions.get(
-                                            NSCertTypeExtension.NAME);
+                                            NSCertTypeExtension.class.getSimpleName());
 
                                     if (nsExtensions != null) {
                                         updateNSExtension(req, nsExtensions);
@@ -689,7 +689,7 @@ public class ProcessCertReq extends CMSServlet {
                                         BasicConstraintsExtension bcExt = 
                                             (BasicConstraintsExtension)
                                             extensions.get(
-                                                BasicConstraintsExtension.NAME);
+                                                BasicConstraintsExtension.class.getSimpleName());
 
                                         if (bcExt != null) {
                                             Integer bcPathLen = (Integer) bcExt.get(BasicConstraintsExtension.PATH_LEN);
@@ -701,8 +701,8 @@ public class ProcessCertReq extends CMSServlet {
                                                 BasicConstraintsExtension bcExt0 =
                                                     new BasicConstraintsExtension(isCA.booleanValue(), pathLen);
 
-                                                extensions.delete(BasicConstraintsExtension.NAME);
-                                                extensions.set(BasicConstraintsExtension.NAME, (Extension) bcExt0);
+                                                extensions.delete(BasicConstraintsExtension.class.getSimpleName());
+                                                extensions.set(BasicConstraintsExtension.class.getSimpleName(), (Extension) bcExt0);
                                                 alterationCounter++;
                                             }
                                         }
@@ -774,14 +774,15 @@ public class ProcessCertReq extends CMSServlet {
                                 }
 
                                 if (mExtraAgentParams) {
-                                    Enumeration extraparams = req.getParameterNames();
+                                    @SuppressWarnings("unchecked")
+									Enumeration<String> extraparams = req.getParameterNames();
                                     int l = IRequest.AGENT_PARAMS.length() + 1;
                                     int ap_counter = 0;
-                                    Hashtable agentparamsargblock = new Hashtable();
+                                    Hashtable<String, String> agentparamsargblock = new Hashtable<String, String>();
 
                                     if (extraparams != null) {
                                         while (extraparams.hasMoreElements()) {
-                                            String s = (String) extraparams.nextElement();
+                                            String s = extraparams.nextElement();
 
                                             if (s.startsWith(IRequest.AGENT_PARAMS)) {
                                                 String param_value = req.getParameter(s);
diff --git a/pki/base/common/src/com/netscape/cmscore/apps/CMSEngine.java b/pki/base/common/src/com/netscape/cmscore/apps/CMSEngine.java
index e812cf10a5a6056af7dad81b06c9141bbcef81e9..44934ed8e989f3a1e51a2c7de2e9a1c2516c0cc8 100644
--- a/pki/base/common/src/com/netscape/cmscore/apps/CMSEngine.java
+++ b/pki/base/common/src/com/netscape/cmscore/apps/CMSEngine.java
@@ -119,6 +119,7 @@ import com.netscape.certsrv.ra.IRegistrationAuthority;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.certsrv.request.IRequestQueue;
 import com.netscape.certsrv.request.RequestStatus;
+import com.netscape.cms.servlet.common.CMSRequest;
 import com.netscape.cms.servlet.csadmin.LDAPSecurityDomainSessionTable;
 import com.netscape.cms.servlet.csadmin.SecurityDomainSessionTable;
 import com.netscape.cms.servlet.csadmin.SessionTimer;
@@ -408,7 +409,7 @@ public class CMSEngine implements ICMSEngine {
         }
 
         ACL acl = null;
-        Vector rights = null;
+        Vector<String> rights = null;
         int idx1 = resACLs.indexOf(":");
 
         if (idx1 <= 0) {
@@ -446,7 +447,7 @@ public class CMSEngine implements ICMSEngine {
             }
 
             if (rightsString != null) {
-                rights = new Vector();
+                rights = new Vector<String>();
                 StringTokenizer rtok = new StringTokenizer(rightsString, ",");
 
                 while (rtok.hasMoreTokens()) {
@@ -645,11 +646,11 @@ public class CMSEngine implements ICMSEngine {
         return new ArgBlock();
     }
 
-    public IArgBlock createArgBlock(Hashtable httpReq) {
+    public IArgBlock createArgBlock(Hashtable<String, String> httpReq) {
         return new ArgBlock(httpReq);
     }
 
-    public IArgBlock createArgBlock(String realm, Hashtable httpReq) {
+    public IArgBlock createArgBlock(String realm, Hashtable<String, String> httpReq) {
         return new ArgBlock(realm, httpReq);
     }
 
@@ -827,11 +828,11 @@ public class CMSEngine implements ICMSEngine {
         return new HttpRequestEncoder();
     }
 
-    public Enumeration getSubsystemNames() {
+    public Enumeration<String> getSubsystemNames() {
         return mSSReg.keys();
     }
 
-    public Enumeration getSubsystems() {
+    public Enumeration<ISubsystem> getSubsystems() {
         return mSSReg.elements();
     }
 
@@ -859,7 +860,7 @@ public class CMSEngine implements ICMSEngine {
         IConfigStore ssconfig = mConfig.getSubStore(PROP_SUBSYSTEM);
 
         // count number of dyn loaded subsystems. 
-        Enumeration ssnames = ssconfig.getSubStoreNames();
+        Enumeration<String> ssnames = ssconfig.getSubStoreNames();
         int nsubsystems = 0;
 
         for (nsubsystems = 0; ssnames.hasMoreElements(); nsubsystems++)
@@ -1310,12 +1311,12 @@ public class CMSEngine implements ICMSEngine {
     }
 
     public  void getSubjAltNameConfigDefaultParams(String name,
-        Vector params) {
+        Vector<String> params) {
         GeneralNameUtil.SubjAltNameGN.getDefaultParams(name, params);
     }
 
     public  void getSubjAltNameConfigExtendedPluginInfo(String name,
-        Vector params) {
+        Vector<String> params) {
         GeneralNameUtil.SubjAltNameGN.getExtendedPluginInfo(name, params);
     }
 
@@ -1333,22 +1334,22 @@ public class CMSEngine implements ICMSEngine {
     }
 
     public  void getGeneralNameConfigDefaultParams(String name,
-        boolean isValueConfigured, Vector params) {
+        boolean isValueConfigured, Vector<String> params) {
         GeneralNameUtil.GeneralNameConfig.getDefaultParams(name, isValueConfigured, params);
     }
 
     public  void getGeneralNamesConfigDefaultParams(String name,
-        boolean isValueConfigured, Vector params) {
+        boolean isValueConfigured, Vector<String> params) {
         GeneralNameUtil.GeneralNamesConfig.getDefaultParams(name, isValueConfigured, params);
     }
 
     public  void getGeneralNameConfigExtendedPluginInfo(String name,
-        boolean isValueConfigured, Vector info) {
+        boolean isValueConfigured, Vector<String> info) {
         GeneralNameUtil.GeneralNameConfig.getExtendedPluginInfo(name, isValueConfigured, info);
     }
 
     public  void getGeneralNamesConfigExtendedPluginInfo(String name,
-        boolean isValueConfigured, Vector info) {
+        boolean isValueConfigured, Vector<String> info) {
         GeneralNameUtil.GeneralNamesConfig.getExtendedPluginInfo(name, isValueConfigured, info);
     }
 
@@ -1514,7 +1515,7 @@ public class CMSEngine implements ICMSEngine {
     }
 
     public void terminateRequests() {
-        java.util.Enumeration e = CommandQueue.mCommandQueue.keys();
+        Enumeration<CMSRequest> e = CommandQueue.mCommandQueue.keys();
         
         while (e.hasMoreElements()) {
             Object thisRequest = e.nextElement();
@@ -1833,10 +1834,10 @@ public class CMSEngine implements ICMSEngine {
                         RequestStatus status = checkRevReq.getRequestStatus();
 
                         if (status == RequestStatus.COMPLETE) {
-                            Enumeration enum1 = checkRevReq.getExtDataKeys();
+                            Enumeration<String> enum1 = checkRevReq.getExtDataKeys();
 
                             while (enum1.hasMoreElements()) {
-                                String name = (String) enum1.nextElement();
+                                String name = enum1.nextElement();
 
                                 if (name.equals(IRequest.REVOKED_CERTS)) {
                                     revoked = true;
@@ -1914,7 +1915,7 @@ class WarningListener implements ILogEventListener {
      * and from  source "source". If the parameter is omitted. All entries
      * are sent back.
      */
-    public synchronized NameValuePairs retrieveLogContent(Hashtable req) throws ServletException,
+    public synchronized NameValuePairs retrieveLogContent(Hashtable<String, String>  req) throws ServletException,
             IOException, EBaseException {
         return null;
     }
@@ -1922,7 +1923,7 @@ class WarningListener implements ILogEventListener {
     /**
      * Retrieve log file list.
      */
-    public synchronized NameValuePairs retrieveLogList(Hashtable req) throws ServletException,
+    public synchronized NameValuePairs retrieveLogList(Hashtable<String, String>  req) throws ServletException,
             IOException, EBaseException {
         return null;
     }
@@ -1935,14 +1936,14 @@ class WarningListener implements ILogEventListener {
         return "ConsoleLog";
     }
 
-    public Vector getDefaultParams() {
-        Vector v = new Vector();
+    public Vector<String> getDefaultParams() {
+        Vector<String> v = new Vector<String>();
 
         return v;
     }
 
-    public Vector getInstanceParams() {
-        Vector v = new Vector();
+    public Vector<String> getInstanceParams() {
+        Vector<String> v = new Vector<String>();
 
         return v;
     }
